﻿Imports System
Imports System.Windows.Forms

''' <summary>
''' Класс определяющий новый формат при редактирвоании столбца
''' </summary>
''' <remarks></remarks>
Public Class DescriptionCol
    Inherits DataGridViewColumn

    Public Sub New()
        MyBase.New(New DescriptionCell)
    End Sub

    Public Overrides Property CellTemplate() As System.Windows.Forms.DataGridViewCell
        Get
            Return MyBase.CellTemplate
        End Get
        Set(ByVal value As System.Windows.Forms.DataGridViewCell)
            MyBase.CellTemplate = value
        End Set
    End Property

End Class




''' <summary>
''' Класс определяющий новый формат ячеек
''' </summary>
''' <remarks></remarks>
Public Class DescriptionCell
    Inherits DataGridViewImageCell

    Public Sub New()
        ' Загрузка картинок при создании ячейки
        Dim ucPicture As New uc
        Me.Value = ucPicture.GetPreVew
    End Sub

    Public Overrides Sub InitializeEditingControl(ByVal rowIndex As Integer, ByVal initialFormattedValue As Object, ByVal dataGridViewCellStyle As System.Windows.Forms.DataGridViewCellStyle)
        MyBase.InitializeEditingControl(rowIndex, initialFormattedValue, dataGridViewCellStyle)

        ' Set the value of the editing control to the current cell value.
        MyBase.InitializeEditingControl(rowIndex, initialFormattedValue, _
            dataGridViewCellStyle)

        Dim ctl As ucEditingControl = _
            CType(DataGridView.EditingControl, ucEditingControl)
        ' ctl.ApplyCellStyleToEditingControl(DescriptionCell)

    End Sub

    Public Overrides ReadOnly Property EditType() As System.Type
        Get
            'возращает тип редактируемого контрола
            Return GetType(ucEditingControl)
        End Get
    End Property

    Public Overrides Property ValueType As System.Type
        Get
            Return MyBase.ValueType
        End Get
        Set(ByVal value As System.Type)
            MyBase.ValueType = value
        End Set
    End Property
    'Public Overrides Property ValueType() As Type
    '    Get
    '        ' Return the type of the value that CalendarCell contains.
    '        Return GetType(uc)
    '    End Get
    '    Set(ByVal value As Type)
    '        Return
    '    End Set
    'End Property



    'Public Overrides ReadOnly Property DefaultNewRowValue() As Object
    '    Get
    '        ' возращает значения по умолчанию из ячейки
    '        Return MyBase.DefaultNewRowValue
    '    End Get
    'End Property


   


    'Public Overrides ReadOnly Property DefaultNewRowValue() As Object
    '    Get
    '        ' Use the current date and time as the default value.
    '        Return DateTime.Now
    '    End Get
    'End Property


End Class

Class ucEditingControl
    Inherits uc

    Implements IDataGridViewEditingControl

    Private ouc As New uc
    Private dataGridViewControl As DataGridView
    Private valueIsChanged As Boolean = False
    Private rowIndexNum As Integer

    'Синхронизируем стиль отображения
    Public Sub ApplyCellStyleToEditingControl(ByVal dataGridViewCellStyle As  _
        DataGridViewCellStyle) _
        Implements IDataGridViewEditingControl.ApplyCellStyleToEditingControl
        'Me.Font = dataGridViewCellStyle.Font
        'uc.= dataGridViewCellStyle.ForeColor
        'Me.CalendarMonthBackground = dataGridViewCellStyle.BackColor
    End Sub

    ' Свойство для связи с родительским DataGridView
    Public Property EditingControlDataGridView() As DataGridView _
           Implements IDataGridViewEditingControl.EditingControlDataGridView

        Get
            Return dataGridViewControl
        End Get
        Set(ByVal value As DataGridView)
            dataGridViewControl = value
        End Set

    End Property


    Public Sub New()
        'Me.TextBox1.Text =
    End Sub

    Public Property EditingControlFormattedValue() As Object _
        Implements IDataGridViewEditingControl.EditingControlFormattedValue

        Get
            '  Return Me.ToShortDateString()
        End Get

        Set(ByVal value As Object)
            If TypeOf value Is String Then
                ' Me.Value = DateTime.Parse(CStr(value))
            End If
        End Set

    End Property

    Public Function GetEditingControlFormattedValue(ByVal context _
        As DataGridViewDataErrorContexts) As Object _
        Implements IDataGridViewEditingControl.GetEditingControlFormattedValue

        Return Me.ouc

    End Function



    Public Property EditingControlRowIndex() As Integer _
        Implements IDataGridViewEditingControl.EditingControlRowIndex

        Get
            Return rowIndexNum
        End Get
        Set(ByVal value As Integer)
            rowIndexNum = value
        End Set

    End Property

    Public Function EditingControlWantsInputKey(ByVal key As Keys, _
        ByVal dataGridViewWantsInputKey As Boolean) As Boolean _
        Implements IDataGridViewEditingControl.EditingControlWantsInputKey

        ' Let the DateTimePicker handle the keys listed.
        Select Case key And Keys.KeyCode
            Case Keys.Left, Keys.Up, Keys.Down, Keys.Right, _
                Keys.Home, Keys.End, Keys.PageDown, Keys.PageUp

                Return True

            Case Else
                Return False
        End Select

    End Function

    Public Sub PrepareEditingControlForEdit(ByVal selectAll As Boolean) _
        Implements IDataGridViewEditingControl.PrepareEditingControlForEdit

        ' No preparation needs to be done.

    End Sub

    Public ReadOnly Property RepositionEditingControlOnValueChange() _
        As Boolean Implements _
        IDataGridViewEditingControl.RepositionEditingControlOnValueChange

        Get
            Return False
        End Get

    End Property



    Public Property EditingControlValueChanged() As Boolean _
        Implements IDataGridViewEditingControl.EditingControlValueChanged

        Get
            Return valueIsChanged
        End Get
        Set(ByVal value As Boolean)
            valueIsChanged = value
        End Set

    End Property

    Public ReadOnly Property EditingControlCursor() As Cursor _
        Implements IDataGridViewEditingControl.EditingPanelCursor

        Get
            Return MyBase.Cursor
        End Get

    End Property

    Protected Sub OnValueChanged(ByVal eventargs As EventArgs)

        ' Notify the DataGridView that the contents of the cell have changed.
        valueIsChanged = True
        Me.EditingControlDataGridView.NotifyCurrentCellDirty(True)
        ' MyBase.OnValueChanged(eventargs)

    End Sub

End Class

Public Class Form1
    Inherits Form

    Private dataGridView1 As New DataGridView()

    <STAThreadAttribute()> _
    Public Shared Sub Main()
        Application.Run(New Form1())
    End Sub

    Public Sub New()
        Me.dataGridView1.Dock = DockStyle.Fill
        Me.Controls.Add(Me.dataGridView1)
        Me.Text = "DataGridView calendar column demo"
    End Sub

    Private Sub Form1_Load(ByVal sender As Object, ByVal e As EventArgs) _
        Handles Me.Load

        Dim col As New DescriptionCol
        Me.dataGridView1.Columns.Add(col)
        Me.dataGridView1.RowCount = 5

        Me.dataGridView1.AutoResizeColumns()
        Me.dataGridView1.AutoResizeRows()

        Dim row As DataGridViewRow

        'For Each row In Me.dataGridView1.Rows
        '    Dim ouc As uc = row.Cells(0).Value
        'Next row
        'Dim dd As New ucColumn

        'dataGridView1.AutoResizeRow(0)
    End Sub

End Class
